//Frame che visualizza la stringa "CIAO" al centro

import javax.swing.*;
import java.awt.*;

class SimpleFrame2 extends JFrame
{
	private int larghezzaSchermo;
	private int altezzaSchermo;
		
	
	//Costruttore:
	public SimpleFrame2 ()
	{
		setTitle("Frame che saluta!");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		
		Toolkit tk = Toolkit.getDefaultToolkit();
		Dimension dim = tk.getScreenSize();
		
		larghezzaSchermo = (int)(dim.getWidth());
		altezzaSchermo = (int)(dim.getHeight());
		
		setSize (larghezzaSchermo/4, altezzaSchermo/4);
		setLocation ((int)(larghezzaSchermo - getSize().getWidth())/2,
			     (int)(altezzaSchermo - getSize().getHeight())/2);
		
		Container cp = getContentPane();
		cp.add(new PrimoPanel());
	}
}

class PrimoPanel extends JPanel
{
	//non  necessario il costruttore (viene usato quello della superclasse JPanel
	
	public void paintComponent (Graphics g)
	{
		super.paintComponent(g); //importantissimo!
		
		String frase = "CIAO SONO FABIO!";
		
		Dimension dimensioniPanel=getSize();	//restituisce le dim. del pannello
	        int posX=(dimensioniPanel.width-92)/2;	//coordinata x della stringa da disegnare
		int posY=(dimensioniPanel.height-12)/2;	//coordinata y della stringa da disegnare
		g.drawString(frase, posX, posY);	//il contesto grafico disegna la stringa
	}
}

public class HelloApplication
{
	public static void main (String[] args)
	{
		SimpleFrame2 f = new SimpleFrame2 ();
		f.show();
	}
}
