/******************************* ESERCIZIO ************************************

Creare un'applicazione che disegni quadrati o cerchi a seconda se l'ultimo carattere
digitato da tastiera  'q' o 'c' e le cuidimensioni sono assegnate con eventii del mouse

********************************************************************************/

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

//Classe pubblica QuadratiCerchiApp:
public class QuadratiCerchiApp extends Object
{
	//main:
	public static void main (String[] args)
	{
		//creazione di un frame:
		JFrame frame = new QuadratiCerchiFrame();
		
		//visualizzazione del frame creato:
		frame.show();
	}
}

//Classe QuadratiCerchiFrame:
class QuadratiCerchiFrame extends JFrame
{
	//variabili di istanza (dimensioni dello schermo):
	private Dimension dimensioneSchermo;
	private int larghezzaSchermo;
	private int altezzaSchermo;
	public char ultimoCarattereDigitato;
	
	//Costruttore:
	public QuadratiCerchiFrame ()
	{
		setTitle ("Disegna i tuoi quadrati ed i tuoi cerchi");
		setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
		
		//ottengo le dimensioni dello schermo dal Toolkit predefinito:
		Toolkit tk = Toolkit.getDefaultToolkit ();
		dimensioneSchermo = tk.getScreenSize ();
		larghezzaSchermo = dimensioneSchermo.width;
		altezzaSchermo = dimensioneSchermo.height;
		
		//setto le dimensioni ed il posizionamento del frame:
		setSize (larghezzaSchermo/2, altezzaSchermo/2);
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		
		//creo ed aggiungo al contentpane il nuovo pannello:
		Container contentPane = getContentPane ();
		QuadratiCerchiPanel pannello = new QuadratiCerchiPanel(this);
		contentPane.add (pannello);
		
		ultimoCarattereDigitato = 'a';
		
		//aggiungo l'ascoltatore apposito per registrare gli eventi da tastiera:
		addKeyListener (new KeyAdapter () {
			public void keyPressed (KeyEvent e)
			{
			}
		});
		
		
	}
	
	//metodo pubblico per accedere alle variabili di istanza:
	public Dimension getDimensioneSchermo ()		{ return dimensioneSchermo;	}
	public int getLarghezzaSchermo ()			{ return larghezzaSchermo;	}
	public int getAltezzaSchermo ()				{ return altezzaSchermo;	}
}

//Classe QuadratiCerchiPanel:
class QuadratiCerchiPanel extends JPanel
{
	private int dim;
		
	//Costruttore:
	public QuadratiCerchiPanel (QuadratiCerchiFrame frame)
	{
		super();
		
		//cambio lo sfondo del pannello:
		setBackground (Color.yellow);
		
		//aggiungo l'ascoltatore apposito per registrare gli eventi del mouse:
		addMouseListener (new MouseAdapter () {
			public void mousePressed (MouseEvent e)
			{
			}
		});			
	}
}
