/* Piccola applicazione che visualizza un JButton all'interno di un frame */

import java.awt.*;
import javax.swing.*;

//Classe pubblica TestButton:
public class TestButton extends Object
{
	//main:
	public static void main (String[] args)
	{
		//creazione del frame:
		JFrame f = new ButtonFrame ();
		
		//visualizzazione del frame:
		f.show();
	}
}

//Classe ButtonFrame:
class ButtonFrame extends JFrame
{
	//Costruttore:
	public ButtonFrame ()
	{
		setTitle ("Un pulsante che non fa nulla");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		setSize (600, 480);
		setLocation (50, 50);
		
		Container cp = getContentPane();
		cp.add (new ButtonPanel ());
	}
}

//Classe ButtonPanel:
class ButtonPanel extends JPanel
{
	//Costruttore:
	public ButtonPanel ()
	{
		super ();
		
		//setto background e foreground del pannello:
		//setBackground (Color.gray);
		setForeground (Color.red);
		
		//aggiungo un JButton al pannello:
		JButton button = new JButton ("Un bottone inutile");
		add (button);
	}
}
