/* Programma per testare la creazione di un pannello all'interno di un frame */

import javax.swing.*;
import java.awt.*;

//Classe pubblica con il metodo main:
public class TestPannelloEx extends Object
{
	//main:
	public static void main (String[] args)
	{
		JFrame f = new TestFrame ();
		
		f.show();
	}
}

//Classe JFrame:
class TestFrame extends JFrame
{
	//Costruttore:
	public TestFrame ()
	{
		System.out.println ("Sto creando il frame");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		setTitle ("Test della classe JPanel");
		setLocation (50, 35);
		setSize (400, 300);
		
		System.out.println ("Sto aggiungendo il pannello al contentPane");
		TestPannello p = new TestPannello();
		Container contentPane = getContentPane();
		contentPane.add (p);
	}
}

//Classe JPanel:
class TestPannello extends JPanel
{
	//Reimplementazione del metodo paintComponent:
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
		
		//cambio solamente lo sfondo al pannello:
		System.out.println ("Sto cambiando lo sfondo al pannello");
		setBackground (Color.blue);
	}
}
