// Applicazione che testa la classe ImageIO:

import java.awt.*;
import javax.imageio.*;
import java.awt.image.*;
import java.io.*;

//Classe TestImageIOApp:
public class TestImageIOApp extends Object
{
	//main:
	public static void main (String[] args) throws Exception
	{
		//leggo un file immagine mediante il metodo read della classe ImageIO:
		BufferedImage image = ImageIO.read (new File ("monkey.jpg"));
		
		//stampo le dimensioni dell'immagine caricata:
		System.out.println ("Le dimensioni dell'immagine sono: "+image.getWidth(null)+", "+image.getHeight(null));
		
		//riscrivo l'immagine caricata su disco con un nuovo nome:
		ImageIO.write (image, "JPG", new File ("monkey_2.jpg"));
		
		//salvo l'immagine in formato png:
		ImageIO.write (image, "PNG", new File ("monkey.png"));
	}
}
