//TestMediaTrackerApp.java:

import java.awt.*;
import javax.swing.*;

public class TestMediaTrackerApp 
{
	//main:
	public static void main (String[] args)
	{
		//creo un MediaTracker:
		MediaTracker tracker = new MediaTracker (new JPanel());
		
		//ottengo il Toolkit di default:
		Toolkit toolkit = Toolkit.getDefaultToolkit ();
		
		//ottengo un'immagine:
		Image image = toolkit.getImage ("monkey.jpg");
		
		//aggiungo l'immagine al MediaTracker:
		tracker.addImage (image, 0);
		
		//attendo il caricamento dell'immagine:
		try
		{
			tracker.waitForID (0);
		}
		catch (InterruptedException e)
		{
			System.out.println (e);
		}
		
		//stampo le dimensioni dell'immagine:
		System.out.println ("Le dimensioni dell'immagine sono: "+image.getWidth(null)+", "+image.getHeight(null));
	}
}
