/*
private void negativo1()
{
	//Recupero le dimensioni dell'immagine
	int w=image.getWidth();
	int h=image.getHeight();
	long start=System.currentTimeMillis();
	//Per tutti i pixel dell'immagine
	for (int x=0;x<w;x++)
	for (int y=0;y<h;y++)
	{
		//Recupero le componenti RGB del pixel
		int colore=image.getRGB(x,y);
		int a=colore&0xFF000000;
		int r=(colore&0x00FF0000)>>16;
		int g=(colore&0x0000FF00)>>8;
		int b=colore&0x000000FF;
		//Ne imposto il negativo
		r=255-r;
		g=255-g;
		b=255-b;
		//Assegno il colore negativo al pixel
		colore=a|(r<<16)|(g<<8)|b;
		image.setRGB(x,y,colore);
	}
	long stop=System.currentTimeMillis();
	JOptionPane.showMessageDialog(this,"Tempo impiegato: "+(stop-start)+" ms");
	//Ridisegno il pannello
	pannello.repaint();
	salvato=false;
}

private void negativo2()
{
	long start=System.currentTimeMillis();
	//Creo il contesto grafico dell'immagine
	Graphics2D g2=image.createGraphics();
	//Imposto come colore il bianco
	g2.setColor(Color.white);
	//Imposto la modalit XOR e come colore XOR il nero
	g2.setXORMode(Color.black);
	
	//Riempio l'immagine con un rettangolo grande quando l'immagine,
	//questa operazione corrisponde a negare l'immagine (Perch??)
	g2.fillRect(0,0,image.getWidth(),image.getHeight());
	//Rilascio le risorse
	g2.dispose();
	long stop=System.currentTimeMillis();
	JOptionPane.showMessageDialog(this,"Tempo impiegato: "+(stop-start)+" ms");
	//Ridisegno il pannello
	pannello.repaint();
	salvato=false;
}

private void negativo3()
{
	//Recupero le dimensioni dell'immagine
	int w=image.getWidth();
	int h=image.getHeight();
	long start=System.currentTimeMillis();
	//Creo una nuova immagine buffer
	BufferedImage buff=new BufferedImage(w,h,BufferedImage.TYPE_INT_ARGB);
	//Creo una LUT che assegna ad ogni colore il suo negativo
	short[][] data=new short[4][256];
	for (int i=0;i<256;i++)
	{
		data[0][i]=(short)(255-i);
		data[1][i]=(short)(255-i);
		data[2][i]=(short)(255-i);
		data[3][i]=255;
	}
	ShortLookupTable table=new ShortLookupTable(0,data);
	//Creo un filtro LUT
	LookupOp filtro=new LookupOp(table,null);
	//Eseguo la LUT
	filtro.filter(image,buff);
	long stop=System.currentTimeMillis();
	JOptionPane.showMessageDialog(this,"Tempo impiegato: "+(stop-start)+" ms");
	//Ricopio il risultato sull'immagine originale
	Graphics2D g2=image.createGraphics();
	g2.drawImage(buff,0,0,null);
	//Rilascio le risorse
	g2.dispose();
	//Ridisegno il pannello
	pannello.repaint();
	salvato=false;
}

private void soglia()
{
	//Recupero le dimensioni dell'immagine
	int w=image.getWidth();
	int h=image.getHeight();
	//Creo una nuova immagine buffer
	BufferedImage buff=new BufferedImage(w,h,BufferedImage.TYPE_INT_ARGB);
	//Creo una LUT che assegna ad ogni colore 0 se  inferiore a 128, 255 se  superiore a 128
	short[][] data=new short[4][256];
	for (int i=0;i<256;i++)
	{
		data[0][i]=(short)(i/128*255);
		data[1][i]=(short)(i/128*255);
		data[2][i]=(short)(i/128*255);
		data[3][i]=255;
	}
	ShortLookupTable table=new ShortLookupTable(0,data);
	//Creo un filtro LUT
	LookupOp filtro=new LookupOp(table,null);
	//Eseguo la LUT
	filtro.filter(image,buff);
	//Ricopio il risultato sull'immagine originale
	Graphics2D g2=image.createGraphics();
	g2.drawImage(buff,0,0,null);
	//Rilascio le risorse
	g2.dispose();
	//Ridisegno il pannello
	pannello.repaint();
	salvato=false;
}
private void sfuma()
{
	//Recupero le dimensioni dell'immagine
	int w=image.getWidth();
	int h=image.getHeight();
	//Creo una nuova immagine buffer
	BufferedImage buff=new BufferedImage(w,h,BufferedImage.TYPE_INT_ARGB);
	//Creo la matrice del kernel
	float[] data=new float[]
	{
		0.111F,0.111F,0.111F,
		0.111F,0.111F,0.111F,
		0.111F,0.111F,0.111F
	};
	//creo il kernel
	Kernel k=new Kernel(3,3,data);
	//Creo il filtro convolutivo
	ConvolveOp op=new ConvolveOp(k);
	//Eseguo il filtro
	op.filter(image,buff);
	//Ricopio il risultato sull'immagine originale
	Graphics2D g2=image.createGraphics();
	g2.drawImage(buff,0,0,null);
	//Rilascio le risorse
	g2.dispose();
	//Ridisegno il pannello
	pannello.repaint();
	salvato=false;
}

private void esaltaBordi()
{
	//Recupero le dimensioni dell'immagine
	int w=image.getWidth();
	int h=image.getHeight();
	//Creo una nuova immagine buffer
	BufferedImage buff=new BufferedImage(w,h,BufferedImage.TYPE_INT_ARGB);
	//Creo la matrice del kernel
	float[] data=new float[]
	{
		0F,-1F, 0F,
		-1F, 5F,-1F,
		0F,-1F, 0F
	};
	//creo il kernel
	Kernel k=new Kernel(3,3,data);
	//Creo il filtro convolutivo
	ConvolveOp op=new ConvolveOp(k);
	//Eseguo il filtro
	op.filter(image,buff);
	//Ricopio il risultato sull'immagine originale
	Graphics2D g2=image.createGraphics();
	g2.drawImage(buff,0,0,null);
	//Rilascio le risorse
	g2.dispose();
	//Ridisegno il pannello
	pannello.repaint();
	salvato=false;
}

private void estraiBordi()
{
	//Recupero le dimensioni dell'immagine
	int w=image.getWidth();
	int h=image.getHeight();
	//Creo una nuova immagine buffer
	BufferedImage buff=new BufferedImage(w,h,BufferedImage.TYPE_INT_RGB);
	//Creo la matrice del kernel
	float[] data=new float[]
	{
		0F,-1F, 0F,
		-1F, 4F,-1F,
		0F,-1F, 0F
	};
	//creo il kernel
	Kernel k=new Kernel(3,3,data);
	//Creo il filtro convolutivo
	ConvolveOp op=new ConvolveOp(k);
	//Eseguo il filtro
	op.filter(image,buff);
	//Ricopio il risultato sull'immagine originale
	Graphics2D g2=image.createGraphics();
	g2.drawImage(buff,0,0,null);
	//Rilascio le risorse
	g2.dispose();
	//Ridisegno il pannello
	pannello.repaint();
	salvato=false;
}

private void derivataX()
{
	//Recupero le dimensioni dell'immagine
	int w=image.getWidth();
	int h=image.getHeight();
	//Creo una nuova immagine buffer
	BufferedImage buff=new BufferedImage(w,h,BufferedImage.TYPE_INT_RGB);
	//Creo la matrice del kernel
	float[] data=new float[]
	{
		-1F, 0F, 1F,
		-1F, 0F, 1F,
		-1F, 0F, 1F
	};
	//creo il kernel
	Kernel k=new Kernel(3,3,data);
	//Creo il filtro convolutivo
	ConvolveOp op=new ConvolveOp(k);
	//Eseguo il filtro
	op.filter(image,buff);
	//Ricopio il risultato sull'immagine originale
	Graphics2D g2=image.createGraphics();
	g2.drawImage(buff,0,0,null);
	//Rilascio le risorse
	g2.dispose();
	//Ridisegno il pannello
	pannello.repaint();
	salvato=false;
}

private void derivataY()
{
	//Recupero le dimensioni dell'immagine
	int w=image.getWidth();
	int h=image.getHeight();
	//Creo una nuova immagine buffer
	BufferedImage buff=new BufferedImage(w,h,BufferedImage.TYPE_INT_RGB);
	//Creo la matrice del kernel
	float[] data=new float[]
	{		
		-1F,-1F,-1F,
		0F, 0F, 0F,
		1F, 1F, 1F
	};
	//creo il kernel
	Kernel k=new Kernel(3,3,data);
	//Creo il filtro convolutivo
	ConvolveOp op=new ConvolveOp(k);
	//Eseguo il filtro
	op.filter(image,buff);
	//Ricopio il risultato sull'immagine originale
	Graphics2D g2=image.createGraphics();
	g2.drawImage(buff,0,0,null);
	//Rilascio le risorse
	g2.dispose();
	//Ridisegno il pannello
	pannello.repaint();
	salvato=false;
	}

private void riscala()
{
	//Recupero le dimensioni dell'immagine
	int w=image.getWidth();
	int h=image.getHeight();
	//Creo una nuova immagine buffer
	BufferedImage buff=new BufferedImage(w,h,BufferedImage.TYPE_INT_ARGB);
	//Imposto il fattore di scala e l'offset
	float[] scale=new float[] {1.5f,1.5f,1.5f,1};
	float[] offset=new float[] {1.0f,1.0f,1.0f,0};
	//Creo il filtro di riscalatura
	RescaleOp op=new RescaleOp(scale,offset,null);
	//Eseguo il filtro
	op.filter(image,buff);
	//Ricopio il risultato sull'immagine originale
	Graphics2D g2=image.createGraphics();
	g2.drawImage(buff,0,0,null);
	//Rilascio le risorse
	g2.dispose();
	//Ridisegno il pannello
	pannello.repaint();
	salvato=false;
}

private void grigio()
{
	//Recupero le dimensioni dell'immagine
	int w=image.getWidth();
	int h=image.getHeight();
	//Creo una nuova immagine buffer
	BufferedImage buff=new BufferedImage(w,h,BufferedImage.TYPE_INT_ARGB);
	//Ottengo lo spazio dei colori per i toni di grigio
	ColorSpace cs=ColorSpace.getInstance(ColorSpace.CS_GRAY);
	//Creo il filtro ci conversione dei colori
	ColorConvertOp op=new ColorConvertOp(cs,null);
	//Eseguo il filtro
	op.filter(image,buff);
	//Ricopio il risultato sull'immagine originale
	Graphics2D g2=image.createGraphics();
	g2.drawImage(buff,0,0,null);
	//Rilascio le risorse
	g2.dispose();
	//Ridisegno il pannello
	pannello.repaint();
	salvato=false;
}*/