/* Applicazione che scrive su un pannello la stringa "CIAO" l'esatto numero di volte affinch si riempi il pannello stesso */

import java.awt.*;
import javax.swing.*;

public class CiaoApplicazione extends Object
{
	//main:
	public static void main (String[] args)
	{
		CiaoFrame f = new CiaoFrame ();
		
		f.show();
	}
}

//Frame:
class CiaoFrame extends JFrame
{
	//Costruttore:
	public CiaoFrame ()
	{
		setTitle ("Ciao Applicazione!!!");
		setLocation (50, 35);
		setSize (600, 480);
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		
		CiaoPannello p = new CiaoPannello();
		Container cp = getContentPane();
		cp.add (p);
	}
}

//Panel:
class CiaoPannello extends JPanel
{
	//paintComponent():
	public void paintComponent (Graphics g)
	{
		super.paintComponent(g);
		
		setBackground (Color.white);
		Dimension dimensioniPannello = this.getSize();
		int larghezzaPannello = dimensioniPannello.width;
		int altezzaPannello = dimensioniPannello.height;
		System.out.println ("Le dimensioni del pannello sono "+larghezzaPannello+"x"+altezzaPannello);
		String frase = "CIAO";
		int posX, posY;
		for (posY = 0; posY < altezzaPannello; posY += 12)
			for (posX = 0; posX < larghezzaPannello; posX += 32)
				g.drawString (frase, posX, posY);
	}
}
