/* Scheletro di una applicazione grafica standard */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;

public class FigureInscritteApp
{
	//main:
	public static void main (String[] args)
	{
		int lati = 4;
		//creazione del frame:
		JFrame frame = new FigureInscritteFrame (lati);
		
		//visualizzazione del frame:
		frame.show();
	}
}

//Classe non pubblica che implementa il frame per l'applicazione:
class FigureInscritteFrame extends JFrame implements ActionListener
{
	//variabili di istanza:
	private Dimension dimensioneSchermo;
	private int larghezzaSchermo, altezzaSchermo;
	private int lati;
	
	//Costruttore:
	public FigureInscritteFrame (int lati)
	{
		this.lati = lati;
		
		setTitle ("Figure Inscritte in una circonferenza");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		
		//ottengo il Toolkit di default:
		Toolkit tk = Toolkit.getDefaultToolkit ();
		dimensioneSchermo = tk.getScreenSize ();
		larghezzaSchermo = dimensioneSchermo.width;
		altezzaSchermo = dimensioneSchermo.height;
		
		//setto le dimensioni del frame:
		setSize (larghezzaSchermo/2, altezzaSchermo/2);
		//setto la posizione del frame:
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		
		//creo i due pannelli necessari:
		FigureInscrittePanel p1 = new FigureInscrittePanel (lati);
		getContentPane().add (p1);
	}
	
	//definizione del metodo ActionPerformed dell'interfaccia ActionListener
	public void actionPerformed (ActionEvent e)
	{
		Object source = e.getSource();
	}
}

//Classe non pubblica MioPannello:
class FigureInscrittePanel extends JPanel
{
	private int lati;
		
	//Costruttore:
	public FigureInscrittePanel (int lati)
	{
		super ();
		this.lati = lati;
	}
	
	//ridefinizione del metodo paintComponent():
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
		
		g.setColor (Color.black);
		int latoMinore;
		if (getSize().width < getSize().height)
			latoMinore = getSize().width;
		else	latoMinore = getSize().height;
			
		//disegno una circonferenza:
		g.drawOval ((getSize().width-latoMinore)/2, (getSize().height-latoMinore)/2, latoMinore-1, latoMinore-1);
		
		g.setColor (Color.white);
		//disegno un poligono di n lati:
		double []coordX = new double [lati];
		double []coordY = new double [lati];
	}
}

