//Applicazione che visualizza 6 frames colorati sullo schermo:

import javax.swing.*;
import java.awt.*;

public class FramesColorati
{
	public static void main (String[] args)
	{
		FrameColorato f1 = new FrameColorato (Color.blue);
		FrameColorato f2 = new FrameColorato (Color.magenta);
		FrameColorato f3 = new FrameColorato (Color.yellow);
		FrameColorato f4 = new FrameColorato (Color.white);
		FrameColorato f5 = new FrameColorato (Color.red);
		FrameColorato f6 = new FrameColorato (Color.green);
		
		int m=0, n=0;
		f1.setLocation(0,0);
		f2.setLocation(m+=f1.getSize().getWidth(),0);
		f3.setLocation(m+=f2.getSize().getWidth(),0);
		m=0;
		f4.setLocation(0,n+=f1.getSize().getHeight());
		f5.setLocation(m+=f4.getSize().getWidth(),n);
		f6.setLocation(m+=f5.getSize().getWidth(),n);
		
		f1.show();
		f2.show();
		f3.show();
		f4.show();
		f5.show();
		f6.show();
	}
}

class FrameColorato extends JFrame
{
	private Color color;
	private int b, h;
		
	public FrameColorato (Color c)
	{
		color = c;
		
		Toolkit tk = Toolkit.getDefaultToolkit();
		Dimension d = tk.getScreenSize();
		b = d.width;
		h = d.height;
		
		setSize (b/4, h/4);
		
		Container cp = getContentPane();
		cp.add(new PanelColorato(color));
	}
	
	public int getLarghezzaSchermo ()
	{	return b;
	}
	
	public int getAltezzaSchermo ()
	{	return h;
	}
	
	public String getColor ()
	{
		return color.toString();
	}
}

class PanelColorato extends JPanel
{
	private Color color;
	/**/	
	public PanelColorato (Color c)
	{
		super();
		color = c;
	}
	
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
		setBackground (color);
	}
}
