/* Applicazione che disegna linee casuali all'interno di una circonferenza rappresentata in un frame */

import java.awt.*;
import javax.swing.*;

//Classe pubblica LineeCasualiApp2:
public class LineeCasualiApp2 extends Object
{
	//main:
	public static void main (String[] args)
	{
		//creazione del frame:
		JFrame frame = new LineeCasualiFrame2 ();
		
		//visualizzazione del frame:
		frame.show();
	}
}

//Classe LineeCasualiFrame2:
class LineeCasualiFrame2 extends JFrame
{
	//Costruttore:
	public LineeCasualiFrame2 ()
	{
		setTitle ("Tante linee casuali!");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		Toolkit tk = Toolkit.getDefaultToolkit();
		Dimension dimensioneSchermo = tk.getScreenSize();
		int larghezzaSchermo = dimensioneSchermo.width;
		int altezzaSchermo = dimensioneSchermo.height;
		setSize (600, 600);
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		setResizable (false);
		LineeCasualiPanel2 p = new LineeCasualiPanel2 ();
		Container cp = getContentPane ();
		cp.add (p);
	}
}

//Classe LineeCasualiPanel2:
class LineeCasualiPanel2 extends JPanel
{
	//Costruttore:
	public LineeCasualiPanel2 ()
	{
		super();
		setBackground (Color.white);
	}
	
	//paintComponent():
	public void paintComponent (Graphics g)
	{
		super.paintComponent(g);
		
		//ottengo le dimensioni del pannello:
		int larghezzaPannello = this.getSize().width;
		int altezzaPannello = this.getSize().height;
		
		//rappresento una circonferenza di colore nero:
		g.setColor (Color.black);
		g.drawOval (0, 0, larghezzaPannello-1, altezzaPannello-1);
		
		//disegno le linee casuali:
		g.setColor (Color.red);
	}
}
