// Applicazione che visualizza un frame all'interno del quale  possibile disegnare palline colorate mediante il mouse

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

//Classe Pubblica PallineColorateApp:
public class PallineColorateApp extends Object
{
	//main:
	public static void main (String[] args)
	{
		JFrame f = new PallineColorateFrame ();
		f.show();
	}
}

//Classe PallineColorateFrame:
class PallineColorateFrame extends JFrame
{
	//variabili di istanza:
	PallineColoratePanel pannello;
	
	//Costruttore:
	public PallineColorateFrame ()
	{
		setTitle ("Disegna tante palline colorate");
		setLocation (20, 20);
		setSize (800, 600);
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		pannello = new PallineColoratePanel();
		Container cp = getContentPane ();
		cp.add (pannello);
	}
}

//Classe PallineColoratePanel:
class PallineColoratePanel extends JPanel
{
	private int dim;
		
	//Costruttore:
	public PallineColoratePanel ()
	{
		super ();
		dim = 10;
		setBackground (Color.yellow);
		addMouseListener (new MouseAdapter () {
			public void mousePressed (MouseEvent e)
			{
				Graphics g = getGraphics();
				if (e.getButton() == 1)
				{
					g.setColor (Color.red);
					g.fillOval (e.getX(), e.getY(), dim, dim);
				}
				else if (e.getButton() == 3)
				{
					g.setColor (Color.black);
					g.fillOval (e.getX(), e.getY(), 2*dim, 2*dim);
				}
				g.dispose();
			}
		});
	}
}
