// Applicazione che visualizza un frame all'interno del quale  possibile disegnare palline colorate mediante il mouse

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

//Classe Pubblica PallineColorateApp:
public class PallineColorateApp2 extends Object
{
	//main:
	public static void main (String[] args)
	{
		JFrame f = new PallineColorateFrame2 ();
		f.show();
	}
}

//Classe PallineColorateFrame:
class PallineColorateFrame2 extends JFrame
{
	//variabili di istanza:
	PallineColoratePanel2 pannello;
	
	//Costruttore:
	public PallineColorateFrame2()
	{
		setTitle ("Disegna tante palline colorate");
		setLocation (20, 20);
		setSize (800, 600);
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		pannello = new PallineColoratePanel2 ();
		Container cp = getContentPane ();
		cp.add (pannello);
	}
}

//Classe PallineColoratePanel:
class PallineColoratePanel2 extends JPanel
{
	private int dim;
		
	//Costruttore:
	public PallineColoratePanel2 ()
	{
		super ();
		dim = 25;
		setBackground (Color.black);
		addMouseMotionListener (new MouseMotionAdapter () {
			public void mouseDragged (MouseEvent e)
			{
				System.out.println ("Evento: "+e);
				Graphics g = getGraphics();
				g.setColor (Color.yellow);
				g.fillOval (e.getX(), e.getY(), dim, dim);
				g.dispose();
			}
		});
	}
}
