//PoligoniApplicazione.java:

import java.awt.*;
import javax.swing.*;

public class PoligoniApplicazione extends Object
{
	//main:
	public static void main (String[] args)
	{
		JFrame f = new PoligoniFrame ();
		f.show();
	}
}

//Classe PoligoniFrame:
class PoligoniFrame extends JFrame
{
	//Costruttore:
	public PoligoniFrame ()
	{
		setTitle ("Applicazione che visualizza poligoni");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		Toolkit tk = Toolkit.getDefaultToolkit ();
		Dimension dimensioneSchermo = tk.getScreenSize ();
		int larghezzaSchermo = dimensioneSchermo.width;
		int altezzaSchermo = dimensioneSchermo.height;
		setSize (larghezzaSchermo/4, altezzaSchermo/4);
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		PoligoniPanel p = new PoligoniPanel ();
		Container cp = getContentPane ();
		cp.add (p);
	}
}

//Classe PoligoniPanel:
class PoligoniPanel extends JPanel
{
	//Costruttore:
	public PoligoniPanel ()
	{
		super ();
		setBackground (Color.white);
	}
	
	//paintComponent():
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
		
		System.out.println ("Disegno un segmento");
		g.setColor (Color.black);
		g.drawLine ((int)(200*Math.random()), (int)(20*Math.random()), (int)(1000*Math.random()), (int)(1000*Math.random()));
		
		System.out.println ("Disegno un poligono chiuso");
		Polygon p = new Polygon();
		p.addPoint (10, 10);
		p.addPoint (80, 10);		p.addPoint (80, 80);
		p.addPoint (10, 60);
		g.drawPolygon (p);
		
		System.out.println ("Disegno un poligono chiuso");
		Polygon pol = new Polygon ();
		for (int i = 0; i < (int)(20*Math.random()+1); i++)
			pol.addPoint ((int)(200*Math.random()+1), (int)(200*Math.random()+1));
		g.drawPolygon (pol);
		
		System.out.println ("Disegno una spezzata aperta");
		int [] xCoord = {20, 90, 90, 20};
		int [] yCoord = {20, 20, 90, 90};
		g.drawPolyline (xCoord, yCoord, 4);
	}
}
