//PrimaApplicazione.java

import java.awt.*;
import javax.swing.*;

//Classe non pubblica per instanziare un oggetto di tipo frame
class PrimoFrame extends JFrame
{
	public static final int HEIGHT = 300;
	public static final int WIDTH = 400;
	public static final int X = 100;
	public static final int Y = 50;
	
	//Costruttore:
	public PrimoFrame ()
	{
		//titolo del frame:
		setTitle ("Il mio primo frame!");
		
		//dimensione (in pixel):
		setSize (WIDTH, HEIGHT);
		
		//posizione:
		setLocation (X, Y);
		
		//operazione di chiusura:
		setDefaultCloseOperation(EXIT_ON_CLOSE);
	}
}

//Classe pubblica per l'esecuzione del frame creato
public class PrimaApplicazione
{
	public static void main (String[] args)
	{
		//Il frame viene instanziato
		JFrame f1 = new PrimoFrame();
		
		//Il frame viene mostrato
		f1.show();
	}
}
