/* Applicazione per testare gli eventi da tastiera */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

//Classe TestKeyEventApp:
public class TestKeyEventApp extends Object
{
	//main:
	public static void main (String[] args)
	{
		(new TestKeyEventFrame()).show();
	}
}

//Classe TestKeyEventFrame:
class TestKeyEventFrame extends JFrame
{
	//Costruttore:
	public TestKeyEventFrame ()
	{
		setTitle ("Test degli eventi da tastiera");
		setSize (600, 480);
		setLocation (20, 20);
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		getContentPane().add (new TestKeyEventPanel());
		addKeyListener (new TestKeyListener());
	}
}

//Classe TestKeyEventPanel:
class TestKeyEventPanel extends JPanel
{
	//Costruttore:
	public TestKeyEventPanel ()
	{
		super ();
	}
}

//Classe KeyEventListener:
class TestKeyListener implements KeyListener
{
	public void keyPressed (KeyEvent e)
	{
		System.out.println ("Evento "+e);
	}
	
	public void keyReleased (KeyEvent e)
	{
		System.out.println ("Evento "+e);
	}
	
	public void keyTyped (KeyEvent e)
	{
		System.out.println ("Evento "+e);
	}
}