/* Applicazione per testare gli eventi relativi al mouse */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

//Classe TestMouseEvent.java:
public class TestMouseEventApp extends Object
{
	//main:
	public static void main (String[] args)
	{
		(new TestMouseEventFrame ()).show();
	}
}

//Classe TestMouseEventFrame:
class TestMouseEventFrame extends JFrame implements MouseListener
{
	//Costruttore:
	public TestMouseEventFrame ()
	{
		setTitle ("Test degli eventi relativi al mouse");
		setLocation (20, 20);
		setSize (600, 480);
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		Container contentPane = getContentPane ();
		contentPane.add (new TestMouseEventPanel ());
		addMouseListener (this);
	}
	
	//implementazione dei metodi previsti dall'interfaccia MouseListener:
	public void mouseClicked (MouseEvent e)
	{
		System.out.println ("Si  verificato l'evento: "+e+". Il mouse  stato cliccato!!!");
	}
	
	public void mouseEntered (MouseEvent e)
	{
		System.out.println ("Si  verificato l'evento: "+e+". Il mouse  entrato nel frame!!!");
	}
	
	public void mouseExited (MouseEvent e)
	{
		System.out.println ("Si  verificato l'evento: "+e+". Il mouse  uscito dal frame!!!");
	}

	public void mousePressed (MouseEvent e)
	{
		System.out.println ("Si  verificato l'evento: "+e+". Il mouse  stato pressato!!!");
	}
	
	public void mouseReleased (MouseEvent e)
	{
		System.out.println ("Si  verificato l'evento: "+e+". Il mouse  stato rilasciato!!!");
	}
}	

//Classe TestMouseEventPanel:
class TestMouseEventPanel extends JPanel 
//implements MouseMotionListener
{
	//Costruttore:
	public TestMouseEventPanel ()
	{
		super ();
		//addMouseMotionListener (this);
	}
	
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
	}
	/*
	//implementazione dei metodi previsti dall'interfaccia MouseMotionListener:
	public void mouseDragged (MouseEvent e)
	{
		System.out.println ("Si  verificato l'evento: "+e+".");
	}
	
	public void mouseMoved (MouseEvent e)
	{
		System.out.println ("Si  verificato l'evento: "+e+".");
	}*/
}
