/* Applicazione per testare gli eventi relativi al mouse */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

//Classe TestMouseEvent.java:
public class TestMouseEventApp2 extends Object
{
	//main:
	public static void main (String[] args)
	{
		(new TestMouseEventFrame2 ()).show();
	}
}

//Classe TestMouseEventFrame:
class TestMouseEventFrame2 extends JFrame
{
	//Costruttore:
	public TestMouseEventFrame2 ()
	{
		setTitle ("Test degli eventi relativi al mouse (implementazione con Adapter)");
		setLocation (20, 20);
		setSize (600, 480);
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		Container contentPane = getContentPane ();
		contentPane.add (new TestMouseEventPanel2 ());
		addMouseListener (new MouseAdapter () {
			//implementazione dei metodi della classe annidata anonima MyMouseLister
			public void mouseClicked (MouseEvent e)
			{
				System.out.println ("Il test sta funzionando, perch in questo momento hai cliccato sul frame!");
			}
		});
	}
}

//Classe TestMouseEventPanel:
class TestMouseEventPanel2 extends JPanel
{
	//Costruttore:
	public TestMouseEventPanel2 ()
	{
		super ();
	}
	
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
	}
}
