// Open & Save Image Application:


import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.io.*;
import java.awt.image.*;
import javax.imageio.*;
import javax.swing.filechooser.FileFilter;

//Classe TestJFileChooserApp2:
public class OpenSaveImageApp extends Object
{
	//main:
	public static void main (String[] args)
	{
		JFrame frame = new JFrame ();
		JPanel panel = new JPanel ();
		JLabel label = new JLabel ();
		JMenuBar barraMenu = new JMenuBar ();
		JMenu file = new JMenu ("File");
		JMenuItem apri = new JMenuItem ("Apri");
		JMenuItem salva = new JMenuItem ("Salva");
		JMenuItem esci = new JMenuItem ("Esci");
		JFileChooser fileChooser = new JFileChooser();
		
		//setto i filtri del JFileChooser:
		fileChooser.setAcceptAllFileFilterUsed (false);
		fileChooser.setFileFilter (new JPGFilter());
		fileChooser.setFileFilter (new PNGFilter());
		
		frame.setTitle ("Esempio di apertura di un file");
		frame.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
		frame.setSize (1024, 702);
		
		frame.getContentPane().add (panel);
		frame.getContentPane().add (label);
		frame.setJMenuBar (barraMenu);
		barraMenu.add (file);
		file.add (apri);
		file.add (salva);
		file.add (esci);
		
		apri.addActionListener (new OpenListener2 (label, fileChooser));
		salva.addActionListener (new SaveListener (label, fileChooser));
		esci.addActionListener (new EsciListener ());
		
		frame.show();
	}
}

//Classe OpenListener2

//Classe PNGFilter

//Classe JPGFilter

//Classe SaveListener: 
class SaveListener implements ActionListener
{
	//variabili di istanza:
	private JLabel label;
	private JFileChooser fileChooser;
		
	//Costruttore:
	public SaveListener (JLabel label, JFileChooser fileChooser)
	{
		this.label = label;
		this.fileChooser = fileChooser;
	}
	
	//implementazione del metodo astratto actionPerformed dell'interfaccia ActionListener
	public void actionPerformed (ActionEvent e)
	{
	}
}
