// Test della classe JFileChooser:

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.io.*;
import java.awt.image.*;
import javax.imageio.*;
import javax.swing.filechooser.FileFilter;

//Classe TestJFileChooserApp:
public class TestJFileChooserApp extends Object
{
	//main:
	public static void main (String[] args)
	{
		JFrame frame = new JFrame ();
		JPanel panel = new JPanel ();
		JLabel label = new JLabel ();
		JButton apri = new JButton ("Apri");
		
		frame.setTitle ("Apri un file");
		frame.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
		frame.setSize (600, 480);
		
		frame.getContentPane().add (panel);
		panel.add (apri);
		
		apri.addActionListener (new OpenListener (label, new JFileChooser()));
		
		frame.show();
	}
}

//Classe OpenListener:
class OpenListener implements ActionListener
{
	//variabili di istanza:
	private JFileChooser fileChooser;
	private JLabel label;
		
	//Costruttore:
	public OpenListener (JLabel lb, JFileChooser f)
	{
		label = lb;
		fileChooser = f;
	}
	
	//definizione del metodo actionPerformed:
	public void actionPerformed (ActionEvent e)
	{
		fileChooser.setDialogType (JFileChooser.OPEN_DIALOG);
		int risposta=fileChooser.showOpenDialog(label);
	}
}
